%% geom1

%%

clear
close all
rgb = imread('kodim04.png');
imshow(rgb);

%% imtranslate


out = imtranslate(rgb,[50 20]);
imshow(out);


%%

out = imtranslate(rgb,[100 200],'FillValues',[255 255 0]);
imshow(out);

%%

out = imtranslate(rgb,[100 -100],'OutputView','full');
imshow(out);
size(rgb)
size(out)


%%
% explore fractional pixel translation with a 5 x 5 matrix

% original 
img = zeros(5);
img(3,3)=1
imshow(imresize(img,16,'nearest'));

%%

% translated
out = imtranslate(img,[0.5 0.6]);
imshow(imresize(out,16,'nearest'));
out


%%

% translated back
out2 = imtranslate(out,[-0.5 -0.6]);
imshow(imresize(out2,16,'nearest'));
out2


%% imresize example

out = imresize(rgb,[900 300]);
imshow(out);


%% imrotate


out = imrotate(rgb,15);
imshow(out);
size(rgb)
size(out)


%%

out = imrotate(rgb,15,'crop');
imshow(out)

%%

out2 = imrotate(out,-15,'crop');
imshow(out2)

%%

% compare before and after

do_input = false;
if do_input
    [c2, rect] = imcrop(out2);
else
    rect = [88   88  338  536];
    c2 = imcrop(out2,rect);
end
c1 = imcrop(rgb,rect);
diff = rgb2gray(im2double(c2)) - rgb2gray(im2double(c1));
imshow((4*diff+1)/2);
figure
imhist((diff+1)/2);


%% other operations


g = rgb2gray(im2double(rgb));
close all
imshow(g);
title('original image');
gf = fliplr(g);
figure
imshow(gf);
title('after fliplr');


%%

gf = flipud(g);
imshow(gf);

%%

gf = g';
imshow(gf);


%%


gf = rot90(g);
imshow(gf);


